var PageSearch = function() {
	//dom элементы
	this.el_content = document.getElementById('page_search');

	this.el_input = document.getElementById('page_search_input');
	this.el_results = document.getElementById('page_search_results');
	this.el_search_list = document.getElementById('page_search_list');
	this.el_scroll = document.getElementById('page_search_scroll');

	this.el_btn_keys = [];
	for(var i=1; i <= 44; i++) {
		this.el_btn_keys.push(document.getElementById('page_search_btn'+i));
	}
	this.el_btn_lang = document.getElementById('page_search_btn_lang');
	this.el_btn_space = document.getElementById('page_search_btn_space');
	this.el_btn_del = document.getElementById('page_search_btn_del');

	this.results_index = 0;
	this.results = [];
	this.mode = 0;
	this.chars = ['0123456789-абвгдеёжзийклмнопрстуфхцчшщъыьэюя','0123456789-abcdefghijklmnopqrstuvwxyz'];
	this.el_input.onkeydown = Main.MainKeyHandler;
};

PageSearch.prototype.show = function(category) {
	show(this.el_content);
	
	animateInitY(this.el_results, 0, 0.5);
	//animateInitY(this.el_scroll.children[0], 0, 0.5);
	
	this.setBtns();
	this.showResults();
	this.setResultsBtns();
//	this.el_input.focus();
	
	onKeyBack = function() {buttons[1].el.onmouseover(); buttons[1].el.onclick()};
	onKeyGreen = function() {
	alert('Green pressed');
	alert('x: ' + buttons[60].el.id);
		if (buttons[60]) buttons[60].el.onmouseover();
	};
};

PageSearch.prototype.setBtns = function() {
	var _this = this;
	buttons.clear(10);
	alert('setBtns - here, mode='+_this.mode);
	buttons.setGroup(10, this.el_btn_keys, '4x11', true, function(btn) { _this.btnClick(btn); });
	buttons.set(55, this.el_btn_lang,[44,56,null,null, true], function(btn) {
		removeClass(_this.el_content, ['rus', 'eng']);
		if (_this.mode == 1) {
			_this.mode = 0;
			addClass(_this.el_content, 'rus');
			for(var i=37; i<44; i++) {
				_this.el_btn_keys[i].style.opacity = 1;
				buttons[i-1].down = i+10;
			}
			buttons[46].right = 47;
			buttons[56].up = 47;
			buttons[57].up = 52;
		} else {
			_this.mode = 1;
			addClass(_this.el_content, 'eng');
			for(var i=37; i<44; i++) {
				_this.el_btn_keys[i].style.opacity = 0;
				buttons[i-1].down = 46;
			}
			buttons[46].right = null;
			buttons[56].up = 46;
			buttons[57].up = 46;
		}
	});
	buttons.set(56, this.el_btn_space,[47,57,null,55, true], function(btn) { _this.btnClick(btn); });
	buttons.set(57, this.el_btn_del,[52,null,null,56, true], function(btn) { _this.btnClick(btn); });
	
	buttons[43].down = buttons[44].down = buttons[45].down = 55;
	buttons[46].down = buttons[47].down = buttons[48].down = buttons[49].down = 56;
	buttons[50].down = buttons[51].down = buttons[52].down = buttons[53].down = 57;

	buttons[1].down = 10;
	buttons[10].up = 2;
	buttons[2].down = 10;
	buttons[11].up = buttons[12].up = 3;
	buttons[3].down = 12;
	buttons[13].up = buttons[14].up = buttons[15].up = 4;
	buttons[4].down = 14;
	buttons[16].up = buttons[17].up = buttons[18].up = buttons[19].up = buttons[20].up = 7;
	buttons[7].down = 19;
	
	// fix
		if (_this.mode == 0) {
			for(var i=37; i<44; i++) {
				_this.el_btn_keys[i].style.opacity = 1;
			}
			buttons[46].right = 47;
			buttons[56].up = 47;
			buttons[57].up = 52;
		} else {
			for(var i=37; i<44; i++) {
				_this.el_btn_keys[i].style.opacity = 0;
				buttons[i-1].down = 46;
			}
			buttons[46].right = null;
			buttons[56].up = 46;
			buttons[57].up = 46;
		}
};

PageSearch.prototype.showResults = function() {
	var html = '<div>';
	if (this.results.length > 0) {
		for (var i = 0; i < this.results.length; i++) {
			html += '<div class="sl-item" id="page_search_result_'+i+'"><div class="over">'+this.results[i].title+'</div></div>';
		}
	} else {
		html += '<div class="sl-item" id="page_search_result_1"><div class="over">По вашему запросу ничего не найдено</div></div>';
	}
	html += '<div class="clear"></div></div>';
	widgetAPI.putInnerHTML(this.el_results, html);
	
/*  Отказываемся от скроллирования результатов поиска - ненужное усложнение
	if (this.results.length > 6) {
		show(this.el_scroll);
	} else { */
		hide(this.el_scroll);
/*	}
*/
};

PageSearch.prototype.setResultsBtns = function() {
	var els = [];
	var from = (this.results_index > 0) ? this.results_index - 1 : 0;
	var to = (this.results_index + 6 < this.results.length) ? this.results_index + 6 : this.results.length - 1;
	for (var i = from; i <= to; i++) {
		els.push('page_search_result_'+i);
	}
	
	var _this = this;
	buttons.clear(60);
	buttons.setGroup(60, els, '6x1', true, function(btn) {
		var delta = btn.k - 60;
		showPage('project', _this.results[_this.results_index+delta].project_id);
		//костыль
		removeClass(buttons[7].el, 'act');
		buttons.act_btn = null;
	});
	
	if (buttons[60]) {
		buttons[10].left = buttons[21].left = buttons[32].left = buttons[43].left =buttons[55].left = 60;
		buttons[60].right = 10;
		buttons[1].down = 60;
		buttons[60].up = 1;
	} else {
		buttons[1].down = 10;
		buttons[10].left = buttons[21].left = buttons[32].left = buttons[43].left =buttons[55].left = null;
	}
	if (buttons[61]) {
		buttons[21].left = buttons[32].left = buttons[43].left =buttons[55].left = 61;
		buttons[61].right = 21;
	}
	if (buttons[62]) {
		buttons[32].left = buttons[43].left = buttons[55].left = 62;
		buttons[62].right = 32;
	}
	if (buttons[63]) buttons[63].right = 32;
	if (buttons[64]) {
		buttons[43].left = buttons[55].left = 64;
		buttons[64].right = 43;
	}
	if (buttons[65]) buttons[65].right = 43;
	if (buttons[66]) buttons[66].right = 43;
	if (buttons[67]) buttons[67].right = 43;
};

PageSearch.prototype.btnClick = function(btn) {
	var i = btn.k - 10;
	var c = (i < 44) ? this.chars[this.mode].substr(i,1) : ' ';
	if (this.mode && i >= 37 && i != 46) c = '';
	var str = this.el_input.value;
	var k = str.length; //this.el_input.selectionStart;
	if (i == 47) {
		str = str.substr(0, k-1);
		//str = str.substr(0, k-1)+str.substr(k);
		//k = k - 1;
	} else if (str.length < 13) {
		str = str + c;
		//str = str.substr(0, k)+ c + str.substr(k);
		//k = k + 1;
	}
	this.el_input.value = str;
	//this.el_input.focus();
//	this.el_input.selectionStart = this.el_input.selectionEnd = k;
	alert('[btnClick] ' + buttons.hover_btn.k);
	this.search();
};

PageSearch.prototype.search = function() {
	var str = this.el_input.value;
	if (str) {
		var _this = this;
		Data.search(str, function(results) {
			_this.results = results;
			alert('[search] before showResults: ' + buttons.hover_btn.k);
			_this.showResults();
			_this.results_index = 0;
			alert('[search] before setResultsBtns: ' + buttons.hover_btn.k);
			_this.setResultsBtns();
			show(_this.el_search_list);
		});
	} else {
		this.results = [];
		this.showResults();
		this.results_index = 0;
		this.setResultsBtns();
		hide(this.el_search_list);
	}
};

PageSearch.prototype.hide = function() {
	onKeyBack = onKeyGreen = null;
	hide(this.el_content);
};
